/**
  *  \file planetscentral/net/connstream.cc
  */

#include "planetscentral/net/connstream.h"

#undef EOF
#define EOF -1

ConnectionStreambuf::ConnectionStreambuf(Connection& conn)
    : conn(conn)
{ }

int
ConnectionStreambuf::overflow(int c)
{
    setg(0, 0, 0);
    if (!pptr())
        setp(buffer, buffer);

    std::ptrdiff_t w = pptr() - pbase();
    if (c != EOF) {
        *pptr() = c;
        ++w;
    }

    conn.send(pbase(), w);
    setp(buffer, buffer + sizeof(buffer) - 1);  // one less to allow stuffing one additional character on next call
    return 0;
}

int
ConnectionStreambuf::sync()
{
    if (pptr() && pptr() > pbase())
        return overflow(EOF);
    
    return 0;
}


ConnectionStream::ConnectionStream(Connection& conn)
    : std::ostream(0), sb(conn)
{
    rdbuf(&sb);
}

ConnectionStream::~ConnectionStream()
{
    sb.sync();
}
